






#ifndef __IMAGER_FUNCTIONS2_H__
#define __IMAGER_FUNCTIONS2_H__

int spl_cache_z;
int spl_cache_uid;
int spl_cache_deg;
long rndreg;


int isqrt (long x);

float Gauss (float r, float sigma, int LoG);
double SDEV (double Sx, double Sxx, int N);

int find_nearby_peak (float *data, int n, int srchpt);
float find_fwhm (float *data, int n);

void cub_coeff (double *a, double x, unsigned char type);

double windowfn (double buf, double x, double y, WINDOW_TYPE wndtype);

void combsort_f (float *array, int *links, int size);
void combsort_i (int *array, int *links, int size);

float element_finder (float *data, int k, int n);

fitresult loglogfit (double* x, double* y, int st, int en);
fitresult lsqfit (double* xdata, double* ydata, int st, int en);


/* Natural cubic spline interplation */

typedef struct
{
	int npoints;
	float *coeff_a;
	float *coeff_b;
	float *coeff_c;
	float *coeff_d;
}
spline_block;

void spline_new (spline_block *spl, int numpts, float *v);
float spline_get (spline_block *spl, int segment, float t);
void spline_free (spline_block *spl);


/* Matrix operations */

MFLOAT det2x2 (MFLOAT *A);

MFLOAT pythag (MFLOAT a, MFLOAT b);

int matsolv (MFLOAT *A, MFLOAT *B, int n);
void mat_transpose (MFLOAT *A, int n);
void matmult (MFLOAT* A, MFLOAT* V, int n);
void matmulnm (MFLOAT *R, MFLOAT* A, MFLOAT* V, int n, int m);
void householder_reduction (MFLOAT* A, int n, MFLOAT* D, MFLOAT* E);
void eigen_ql (MFLOAT* A, int n, MFLOAT* D, MFLOAT* E);

void testmatrix ();




#endif
