






#ifndef __IMAGER_RANDGEN_H__
#define __IMAGER_RANDGEN_H__


float nr_rand2 ();			/* Random numbers from 0 to 1, box distribution */
float gauss_rnd ();			/* Gaussian-distribution random numbers, zero mean, SD=1 */
float eran1 ();				/* Exponentially-distributed, positive random numbers of unit mean */
float pnoise (int x, int y, int level);	/* 2D deterministic noise generator for Perlin noise */
float perlin_noise (float x, float y, float H, int octaves);		
							/* Perlin noise synthesizer, H is the persistence, 0<H<1 */

void create_fbm (float* timeseries, float sd, float h, int numpoints, char make_fbm);
							/* FBM random noise by successive random additions */
int create_fbm_2d (image_type *img, float sd, float h, int numpoints, char make_fbm);
void create_fbm_spectral (float *timeseries, float sd, float beta, int numpoints, char make_fbm);
							/* FBM or FBN time series by spectral synthesis */
void create_2d_fbm_spectral (image_type *img, float beta, int numpoints);
							/* FBM 2D data by spectral synthesis */






#endif
